IO::Sized - Crystal 1.19.1

# class IO::Sized

- IO::Sized
- IO
- Reference
- Object

##
Overview

An `IO` that wraps another `IO`, setting a limit for the number of bytes that can be read.

    io = IO::Memory.new "abcde"
    sized = IO::Sized.new(io, read_size: 3)

    sized.gets_to_end # => "abc"
    sized.gets_to_end # => ""
    io.gets_to_end    # => "de"

##
Defined in:

io/sized.cr

##
Constructors

- .new(io : IO, read_size : Int, sync_close : Bool = false)

  Creates a new `IO::Sized` which wraps io, and can read a maximum of read_size bytes.

##
Instance Method Summary

- #close : Nil

  Closes this `IO`.

- #closed? : Bool

  Returns `true` if this `IO` is closed.

- #peek : Bytes | Nil

  Peeks into this IO, if possible.

- #read(slice : Bytes) : Int32

  Reads at most slice.size bytes from this `IO` into slice.

- #read_byte : UInt8 | Nil

  Reads a single byte from this `IO`.

- #read_remaining : UInt64

  The number of remaining bytes to be read.

- #read_remaining=(read_remaining : UInt64)

  The number of remaining bytes to be read.

- #skip(bytes_count) : Nil
- #sync_close=(sync_close : Bool)

  If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`.

- #sync_close? : Bool

  If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`.

- #write(slice : Bytes) : NoReturn

  Writes the contents of slice into this `IO`.

### Instance methods inherited from class `IO`

<<(obj : _) : self <<, close close, closed? : Bool closed?, each_byte(&) : Nil
each_byte each_byte, each_char(&) : Nil
each_char each_char, each_line(*args, **options, &block : String -> ) : Nil
each_line(*args, **options) each_line, encoding : String encoding, flush flush, getb_to_end : Bytes getb_to_end, gets(delimiter : Char, limit : Int, chomp = false) : String | Nil
gets(chomp : Bool = true) : String | Nil
gets(limit : Int, chomp : Bool = false) : String | Nil
gets(delimiter : Char, chomp : Bool = false) : String | Nil
gets(delimiter : String, chomp = false) : String | Nil gets, gets_to_end : String gets_to_end, peek : Bytes | Nil peek, pos pos, pos=(value) pos=, print(obj : _) : Nil
print(*objects : _) : Nil print, printf(format_string : String, args : Array | Tuple) : Nil
printf(format_string : String, *args) : Nil printf, puts(string : String) : Nil
puts(obj : _) : Nil
puts : Nil
puts(*objects : _) : Nil puts, read(slice : Bytes) read, read_at(offset, bytesize, & : IO -> ) read_at, read_byte : UInt8 | Nil read_byte, read_bytes(type, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) read_bytes, read_char : Char | Nil read_char, read_fully(slice : Bytes) : Int32 read_fully, read_fully?(slice : Bytes) : Int32 | Nil read_fully?, read_line(*args, **options) : String read_line, read_string(bytesize : Int) : String read_string, read_utf8(slice : Bytes) : Int32 read_utf8, read_utf8_byte : UInt8 | Nil read_utf8_byte, rewind rewind, seek(offset, whence : Seek = Seek::Set) seek, set_encoding(encoding : String, invalid : Symbol | Nil = nil) : Nil set_encoding, skip(bytes_count : Int) : Nil skip, skip_to_end : Nil skip_to_end, tell tell, tty? : Bool tty?, write(slice : Bytes) : Nil write, write_byte(byte : UInt8) : Nil write_byte, write_bytes(object : _, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) : Nil write_bytes, write_string(slice : Bytes) : Nil write_string, write_utf8(slice : Bytes) : Nil write_utf8

### Class methods inherited from class `IO`

copy(src : IO, dst : IO, limit : Int) : Int64
copy(src : IO, dst : IO) : Int64 copy, pipe(read_blocking : Bool | Nil = nil, write_blocking : Bool | Nil = nil) : Tuple(IO::FileDescriptor, IO::FileDescriptor)
pipe(read_blocking = nil, write_blocking = nil, &) pipe, same_content?(stream1 : IO, stream2 : IO) : Bool same_content?

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(io : IO, read_size : Int, sync_close : Bool = false) #

Creates a new `IO::Sized` which wraps io, and can read a maximum of read_size bytes. If sync_close is set, calling `#close` calls `#close` on the underlying `IO`.

##
Instance Method Detail

def close : Nil #
Description copied from class IO

Closes this `IO`.

`IO` defines this is a no-op method, but including types may override.

def closed? : Bool #
Description copied from class IO

Returns `true` if this `IO` is closed.

`IO` defines returns `false`, but including types may override.

def peek : Bytes | Nil #
Description copied from class IO

Peeks into this IO, if possible.

It returns:

- `nil` if this IO isn't peekable at this moment or at all
- an empty slice if it is, but EOF was reached
- a non-empty slice if some data can be peeked

The returned bytes are only valid data until a next call to any method that reads from this IO is invoked.

By default this method returns `nil`, but IO implementations that provide buffering or wrap other IOs should override this method.

def read(slice : Bytes) : Int32 #
Description copied from class IO

Reads at most slice.size bytes from this `IO` into slice. Returns the number of bytes read, which is 0 if and only if there is no more data to read (so checking for 0 is the way to detect end of file).

    io = IO::Memory.new "hello"
    slice = Bytes.new(4)
    io.read(slice) # => 4
    slice          # => Bytes[104, 101, 108, 108]
    io.read(slice) # => 1
    slice          # => Bytes[111, 101, 108, 108]
    io.read(slice) # => 0

def read_byte : UInt8 | Nil #
Description copied from class IO

Reads a single byte from this `IO`. Returns `nil` if there is no more data to read.

    io = IO::Memory.new "a"
    io.read_byte # => 97
    io.read_byte # => nil

def read_remaining : UInt64 #

The number of remaining bytes to be read.

def read_remaining=(read_remaining : UInt64) #

The number of remaining bytes to be read.

def skip(bytes_count) : Nil #
def sync_close=(sync_close : Bool) #

If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`.

def sync_close? : Bool #

If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`.

def write(slice : Bytes) : NoReturn #
Description copied from class IO

Writes the contents of slice into this `IO`.

    io = IO::Memory.new
    slice = Bytes.new(4) { |i| ('a'.ord + i).to_u8 }
    io.write(slice)
    io.to_s # => "abcd"